# -*- coding: utf-8 -*-

#vérification de la version de scikit-learn
import sklearn
print(sklearn.__version__)

#modifier le working directory
import os
os.chdir("D:/DataMining/Databases_for_mining/dataset_for_soft_dev_and_comparison/arbre_scikit_learn")

#importer les données
import pandas
dfHeart = pandas.read_excel("heart_dataset.xlsx",sheet_name = 0)

#dimensions
print(dfHeart.shape)

#liste des variables
print(dfHeart.info())

#liste des variables quanti
import numpy
lstQuali =  [var for var in dfHeart.columns[:-1] if dfHeart[var].dtype == numpy.object_]
print(lstQuali)

#recoder en 0/1 ces variables
dfQualiEncoded = pandas.get_dummies(dfHeart[lstQuali])
print(dfQualiEncoded.info())

#liste des variables quanti
lstQuanti = [var for var in dfHeart.columns[:-1] if dfHeart[var].dtype != numpy.object_]
print(lstQuanti)

#réunir dummies et quanti dans le même data frame
dfNew = pandas.concat([dfQualiEncoded,dfHeart[lstQuanti]],axis=1)
print(dfNew.info())

#rajouter la variable cible
dfNew['coeur'] = dfHeart.coeur
print(dfNew.info())

#instanciation de l'arbre
from sklearn.tree import DecisionTreeClassifier
arbreHeart = DecisionTreeClassifier(max_depth = 2)

#construction de l'arbre
arbreHeart.fit(X = dfNew.iloc[:,:-1], y = dfNew.coeur)

#affichage graphique de l'arbre - depuis sklearn 0.21
from sklearn.tree import plot_tree
import matplotlib.pyplot as plt
plt.figure(figsize=(15,10))
plot_tree(arbreHeart,feature_names = list(dfNew.columns[:-1]),filled=True)
plt.show()