# -*- coding: utf-8 -*-

#vérification de la version de scikit-learn
import sklearn
print(sklearn.__version__)

#modifier le working directory
import os
os.chdir("D:/DataMining/Databases_for_mining/dataset_for_soft_dev_and_comparison/arbre_scikit_learn")

#importer les données
import pandas
dfVote = pandas.read_excel("vote_simplified.xlsx",sheet_name = 0)

#dimensions
print(dfVote.shape)

#liste et type des variables
print(dfVote.info())

#affichage des premières lignes
print(dfVote.head())

#instanciation de l'arbre
from sklearn.tree import DecisionTreeClassifier
arbreVote = DecisionTreeClassifier(max_depth = 3)

#construction de l'arbre
arbreVote.fit(X = dfVote.iloc[:,:-1], y = dfVote.groupe)

#liste des variables
print(dfVote.columns)

#encodage des prédictives
dfVoteBis = pandas.get_dummies(dfVote[dfVote.columns[:-1]])
print(dfVoteBis.info())

#répartition de la variable crime par ex.
print(dfVote['crime'].value_counts(normalize=True))

#moyennes par variables -- proportions
print(dfVoteBis.apply(func='mean',axis=0))

#ajouter la variabgle 'groupe'
dfVoteBis['groupe'] = dfVote.groupe
print(dfVoteBis.info())

#réinstancier l'arbre de décision
arbreVote = DecisionTreeClassifier(max_depth = 3)

#construction de l'arbre
arbreVote.fit(X = dfVoteBis.iloc[:,:-1], y = dfVoteBis.groupe)

#affichage graphique de l'arbre - depuis sklearn 0.21
from sklearn.tree import plot_tree
import matplotlib.pyplot as plt
plt.figure(figsize=(20,5))
plot_tree(arbreVote,feature_names = list(dfVoteBis.columns[:-1]),filled=True)
plt.show()
